--[[    Filename: BestSeller.lua

        Author  : Smashed - Bladefist
]]--
-- Set up some global stuff

bsVersion = "v"..GetAddOnMetadata("BestSeller", "Version");

BSASLSF_offset=0;

bAutoSellActive=0;
bMerchantOpen=0;
iLastItemSold=0;

RFCC="|cffff2020";
JFCC="|cfff0f090";
PFCC="|cffff20ff";
WFCC="|cffffffff";
NFCC="|cffffd200";
DFCC="|cff888888";
GFCC="|cff00ff00";
BFCC="|cff0000ff";
YFCC="|cffffff00";
OFCC="|cffff9900";

ITEM_QUALITY = {};
ITEM_QUALITY[0] = "|cff9d9d9dPoor";
ITEM_QUALITY[1] = "|cffffffffCommon";
ITEM_QUALITY[2] = "|cff1eff00Uncommon";
ITEM_QUALITY[3] = "|cff0070ffRare";
ITEM_QUALITY[4] = "|cffa335eeEpic";
ITEM_QUALITY[5] = "|cffff8000Legendary";
ITEM_QUALITY[6] = "|cffff0000Artifact";
ITEM_QUALITY[7] = "|cfe6cc80Heirloom";

function bsOnLoad(self)

    SLASH_BestSeller1 = "/bestseller";
    SLASH_BestSeller2 = "/bs";
    SlashCmdList["BestSeller"] = function(msg) bsCommandHandler(self,msg); end

    bsRegisterEvent("AUCTION_BIDDER_LIST_UPDATE");
    bsRegisterEvent("AUCTION_HOUSE_CLOSED");
    bsRegisterEvent("AUCTION_HOUSE_DISABLED");
    bsRegisterEvent("AUCTION_HOUSE_SHOW");
    bsRegisterEvent("AUCTION_ITEM_LIST_UPDATE");
    bsRegisterEvent("AUCTION_MULTISELL_FAILURE");
    bsRegisterEvent("AUCTION_MULTISELL_UPDATE");
    bsRegisterEvent("AUCTION_OWNED_LIST_UPDATE");

--[[
    bsRegisterEvent("CHAT_MSG");
    bsRegisterEvent("CHAT_MSG_COMBAT_XP_GAIN");
    bsRegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE");
    bsRegisterEvent("CHAT_MSG_GUILD");
    bsRegisterEvent("CHAT_MSG_PARTY");
    bsRegisterEvent("CHAT_MSG_PARTY_LEADER");
    bsRegisterEvent("CHAT_MSG_SYSTEM");
    bsRegisterEvent("CHAT_MSG_WHISPER");

    bsRegisterEvent("PLAYER_LEVEL_UP");

    ]]--

    bsRegisterEvent("CHAT_MSG_LOOT");

    bsRegisterEvent("MERCHANT_SHOW");
    bsRegisterEvent("MERCHANT_CLOSED");
    bsRegisterEvent("MERCHANT_UPDATE");

    bsRegisterEvent("PLAYER_LOGOUT");

    bsRegisterEvent("UI_INFO_MESSAGE");
    bsRegisterEvent("UNIT_INVENTORY_CHANGED");
    bsRegisterEvent("UPDATE_CHAT_WINDOWS");

    bsRegisterEvent("VARIABLES_LOADED");

end
function bsNargify(text)
    --bsDPrint(text);
    if(text~=nil) then
        cmd=text;
        for mesg,arg2 in string.gmatch(text, "(.+) (.+)") do text=mesg; arg1=arg2; end
        narg=nil; narg={};
        if(text~=nil) then
            numarg=0;
            for word in string.gmatch(cmd, "%w+") do
                narg[numarg]=strlower(word);
                if(narg[numarg]=="") then narg[numarg]=nil; numarg=numarg-1; end
                --bsDPrint(numarg.." bsNargify Debug Msg: ["..narg[numarg].."]");
                numarg=numarg+1;
            end

            return narg,numarg;
        end
    end
end
function bsRound(what, precision)
return math.floor(what*math.pow(10,precision)+0.5) / math.pow(10,precision)
end
function bsDPrint(a)
    local cf=0;
    if(db) then
        if(db.bsChatFrame==nil) then
            cf=DEFAULT_CHAT_FRAME;
            else
            cf=db.bsChatFrame;
        end

        if(db.BestSellerDebug==1) then
             cf:AddMessage(RFCC.."BSDEBUG>> "..WFCC..a);
        end
    end
end
function bsPrint(a)
    if(a~=nil) then
        DEFAULT_CHAT_FRAME:AddMessage(a);
    end
end
function bsInform(a)
    if(a~=nil) then
        DEFAULT_CHAT_FRAME:AddMessage(RFCC.."BESTSELLER: "..YFCC..a);
    end
end

function bsTell(player,msg)
    bsMsg(player,msg,"WHISPER");
end
function bsMsg(player,msg,where)
    SendChatMessage(msg, where, GetDefaultLanguage("player"), player);
end
function bsGetLink(item)
    if(item==nil) then return nil; end
	for io,iw,ix in string.gmatch(item,"(.+)item:(.+):(.+)") do link="item:"..iw..":0"; end;
	return link;
end

function bsGetEquippedItem(slot)
	bsPrint(slot);
	slotId,what=GetInventorySlotInfo(slot);
	if(slotId~=nil) then return GetInventoryItemLink("player",slotId);
	end
end
function bsGetGold(x)
    if (x~=nil) then
        return floor(abs(x/10000));
    else
        return 0;
    end
end
function bsGetSilver(x)
    if(x~=nil) then
        return floor(abs(mod(x/100,100)));
    else
        return 0;
    end
end
function bsGetCopper(x)
    if(x~=nil) then
        return floor(abs(mod(x,100)));
    else
        return 0;
    end
end
function bsSetDebugWindow()
    -- Determine if a BestSeller Chat Frame is open or not and direct debug output there
    for i = 0,10 do
        name, fontSize, r, g, b, alpha, shown, locked, docked, uninteractable =GetChatWindowInfo(i);
        if(name~=nil) then
            if(name=="Best Seller") then
                if(db) then
                    db.bsChatFrame=getglobal("ChatFrame"..i);
                end
            end
        end
    end
    if(db) then
        if(db.bsChatFrame==nil) then
            db.bsChatFrame=DEFAULT_CHAT_FRAME;
        end
    end
end
---[EOF]
